import { Plugin } from 'vite';

interface RemoteScriptsOptions {
    /**
     * Directory name to store the styles or scripts from remote
     *
     * @default 'node_modules/.remote-scripts'
     */
    assetsDir?: string;
    /**
     * Mark the elements that need to download resources
     *
     * @default data-remote-script
     */
    attributeName?: string;
    /**
     * Prefix appended to the file when bundling
     *
     * @default remote-script
     */
    chunkPrefix?: 'remote-script.';
    /**
     * Mode to resolve urls
     *
     * @default relative
     */
    resolveMode?: 'relative' | '@fs' | ((moduleId: string, url: string) => 'relative' | '@fs');
    /**
     * Wait for download before serving the content
     *
     * @default true
     */
    awaitDownload?: boolean;
}
declare function VitePluginRemoteScripts(options?: RemoteScriptsOptions): Plugin;

export { RemoteScriptsOptions, VitePluginRemoteScripts, VitePluginRemoteScripts as default };
