"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateWrapper = (obj, member, setter, getter) => {
  return {
    set _(value) {
      __privateSet(obj, member, value, setter);
    },
    get _() {
      return __privateGet(obj, member, getter);
    }
  };
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  VitePluginRemoteScripts: () => VitePluginRemoteScripts,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_path = require("path");

// node_modules/.pnpm/@antfu+utils@0.5.2/node_modules/@antfu/utils/dist/index.mjs
function slash(str) {
  return str.replace(/\\/g, "/");
}
var Node = class {
  value;
  next;
  constructor(value) {
    this.value = value;
  }
};
var _head, _tail, _size;
var Queue = class {
  constructor() {
    __privateAdd(this, _head, void 0);
    __privateAdd(this, _tail, void 0);
    __privateAdd(this, _size, void 0);
    this.clear();
  }
  enqueue(value) {
    const node = new Node(value);
    if (__privateGet(this, _head)) {
      __privateGet(this, _tail).next = node;
      __privateSet(this, _tail, node);
    } else {
      __privateSet(this, _head, node);
      __privateSet(this, _tail, node);
    }
    __privateWrapper(this, _size)._++;
  }
  dequeue() {
    const current = __privateGet(this, _head);
    if (!current) {
      return;
    }
    __privateSet(this, _head, __privateGet(this, _head).next);
    __privateWrapper(this, _size)._--;
    return current.value;
  }
  clear() {
    __privateSet(this, _head, void 0);
    __privateSet(this, _tail, void 0);
    __privateSet(this, _size, 0);
  }
  get size() {
    return __privateGet(this, _size);
  }
  *[Symbol.iterator]() {
    let current = __privateGet(this, _head);
    while (current) {
      yield current.value;
      current = current.next;
    }
  }
};
_head = new WeakMap();
_tail = new WeakMap();
_size = new WeakMap();
var VOID = Symbol("p-void");

// src/index.ts
var import_debug = __toESM(require("debug"));
var import_fs_extra2 = require("fs-extra");
var import_node_html_parser = require("node-html-parser");

// src/utils.ts
var import_crypto = require("crypto");
var import_axios = __toESM(require("axios"));
var import_fs_extra = require("fs-extra");
function chunkHash(text) {
  const hex = (0, import_crypto.createHash)("md5").update(text).digest("hex");
  return hex.slice(8, 16);
}
function isValidHttpUrl(str) {
  let url;
  try {
    url = new URL(str);
  } catch (_) {
    return false;
  }
  return url.protocol === "http:" || url.protocol === "https:";
}
async function downloadTo(url, filepath) {
  const writer = (0, import_fs_extra.createWriteStream)(filepath);
  const response = await (0, import_axios.default)({
    url,
    method: "GET",
    responseType: "stream"
  });
  response.data.pipe(writer);
  return new Promise((resolve2, reject) => {
    writer.on("finish", resolve2);
    writer.on("error", reject);
  });
}
function getElementMeta(element, scriptMetas) {
  const tagName = element.tagName;
  const url = element.getAttribute(scriptMetas[tagName].attributeName);
  return {
    tagName: element.tagName,
    url
  };
}

// src/index.ts
var defaultScriptMetas = {
  SCRIPT: {
    attributeName: "src",
    extension: ".js"
  },
  LINK: {
    attributeName: "href",
    extension: ".css"
  }
};
var debug = (0, import_debug.default)("vite-plugin-remote-scripts");
function VitePluginRemoteScripts(options = {}) {
  const {
    assetsDir = "node_modules/.remote-scripts",
    attributeName = "data-remote-script",
    chunkPrefix = "remote-script.",
    resolveMode = "relative",
    awaitDownload = true
  } = options;
  let dir = void 0;
  let config;
  let server;
  const tasksMap = {};
  async function transform(code, id) {
    const root = (0, import_node_html_parser.parse)(code);
    const elements = root.querySelectorAll(`link[${attributeName}], script[${attributeName}]`);
    if (elements.length > 0) {
      const tasks = [];
      let hasReplaced = false;
      for (const element of elements) {
        const meta = getElementMeta(element, defaultScriptMetas);
        if (!meta.url || !isValidHttpUrl(meta.url))
          continue;
        const hash = chunkPrefix + chunkHash(meta.url) + defaultScriptMetas[meta.tagName].extension;
        let filepath;
        if (config.env.PROD) {
          filepath = slash([config.root, config.build.outDir, config.build.assetsDir, hash].join("/"));
        } else {
          filepath = slash((0, import_path.resolve)(dir, hash));
        }
        debug("detected", meta.url, hash);
        if (!(0, import_fs_extra2.existsSync)(filepath) || tasksMap[filepath]) {
          if (!tasksMap[filepath]) {
            tasksMap[filepath] = (async () => {
              try {
                debug("downloading", meta.url);
                await downloadTo(meta.url, filepath);
                debug("downloaded", meta.url);
              } catch (e) {
                if ((0, import_fs_extra2.existsSync)(filepath)) {
                  await (0, import_fs_extra2.unlink)(filepath);
                }
                throw e;
              } finally {
                delete tasksMap[filepath];
              }
            })();
          }
          tasks.push(tasksMap[filepath]);
          if (!config.env.PROD && !awaitDownload) {
            continue;
          }
        }
        hasReplaced = true;
        const mode = typeof resolveMode === "function" ? resolveMode(id, meta.url) : resolveMode;
        let newUrl;
        if (config.env.PROD) {
          newUrl = slash([config.base + config.build.assetsDir, hash].join("/"));
        } else {
          if (mode === "relative") {
            newUrl = slash((0, import_path.relative)((0, import_path.dirname)(id), `${dir}/${hash}`));
            if (newUrl[0] !== ".") {
              newUrl = `./${newUrl}`;
            }
          } else {
            let path = `${dir}/${hash}`;
            if (!path.startsWith("/")) {
              path = `/${path}`;
            }
            newUrl = `/@fs${path}`;
          }
        }
        element.setAttribute(defaultScriptMetas[element.tagName].attributeName, newUrl);
      }
      if (tasks.length) {
        if (config.env.PROD || awaitDownload) {
          await Promise.all(tasks);
        } else {
          Promise.all(tasks).then(() => {
            if (server) {
              const module2 = server.moduleGraph.getModuleById(id);
              if (module2) {
                server.moduleGraph.invalidateModule(module2);
              }
            }
          });
        }
      }
      if (!hasReplaced)
        return null;
      code = root.toString();
    }
    return code;
  }
  async function configResolved(_config) {
    config = _config;
    if (config.env.PROD) {
      dir = slash((0, import_path.resolve)(config.root, config.build.outDir, config.build.assetsDir));
    } else {
      dir = slash((0, import_path.resolve)(config.root, assetsDir));
    }
    if (config.server.force) {
      await (0, import_fs_extra2.emptyDir)(dir);
    }
    await (0, import_fs_extra2.ensureDir)(dir);
  }
  return {
    name: "vite-plugin-remote-scripts",
    enforce: "post",
    configResolved,
    configureServer(_server) {
      server = _server;
    },
    transformIndexHtml: {
      enforce: "post",
      async transform(code, ctx) {
        await configResolved(config);
        return await transform(code, ctx.filename);
      }
    }
  };
}
var src_default = VitePluginRemoteScripts;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  VitePluginRemoteScripts
});
